VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "read values from phone"
   ClientHeight    =   3030
   ClientLeft      =   60
   ClientTop       =   510
   ClientWidth     =   14115
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   14115
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   12480
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "browse to gpx file"
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   720
      Width           =   1455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "read from gpx file"
      Height          =   255
      Left            =   10440
      TabIndex        =   0
      Top             =   720
      Visible         =   0   'False
      Width           =   1455
   End
   Begin VB.Label lblNext 
      BeginProperty Font 
         Name            =   "Comic Sans MS"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   375
      Left            =   1080
      TabIndex        =   4
      Top             =   2040
      Width           =   11775
   End
   Begin VB.Label lblDone 
      BeginProperty Font 
         Name            =   "Comic Sans MS"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   375
      Left            =   1080
      TabIndex        =   3
      Top             =   1440
      Width           =   11775
   End
   Begin VB.Label lblGPXfile 
      Height          =   255
      Left            =   2880
      TabIndex        =   2
      Top             =   720
      Width           =   7335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim button_state As String
Dim phonepath As String
Dim PhotoLoc As String
Dim filename As String
Dim n_survey_obs As Integer
Dim n_captures As Integer

Private Sub Form_Load()

ChDir App.Path
PhotoLoc = App.Path

End Sub

Private Sub cmdBrowse_Click()

CommonDialog1.ShowOpen
lblGPXfile = CommonDialog1.filename
filename = Dir(CommonDialog1.filename, vbDirectory)
phonepath = Mid(lblGPXfile, 1, Len(lblGPXfile) - Len(filename))
'browsing changes default path away from folder containing ExtractCompare.exe
'so change back so that sealw.dll etc. will be read
ChDir App.Path
Command1.Visible = True

End Sub

Private Sub Command1_Click()
Dim strinput As String
Dim i As Integer
Dim lines_read As Integer
Dim a() As String
Dim elements As Integer
Dim lat As Double
Dim lon As Double
Dim ele As String
Dim dt As String
Dim tm As String
Dim dog_type As String
Dim origin As String
Dim event_type As String
Dim sat As String
Dim voiceOSM As String
Dim photoOSM As String

photoOSM = "none"
dog_type = "unset"
origin = "unset"
lines_read = 0
'the OSMtracker app saves waypoints to a gpx file
Open lblGPXfile.Caption For Binary As #1
Open PhotoLoc & "\survey.csv" For Output As #2
Open PhotoLoc & "\captures.csv" For Output As #3
n_survey_obs = 0
n_captures = 0
Do While Not EOF(1)
    'the read_a_line subroutine returns text separated by tabs
    Call read_a_line(1, strinput)
    lines_read = lines_read + 1
    If lines_read > 1 Then
        'after the waypoints ignore the track records
        If Left(strinput, 3) = "trk" Then
            Close #2
            GoTo skip
        End If
        elements = split_on_spaces(strinput, a)
        lat = Mid(a(1), 6, Len(a(1)) - 6)
        lon = Mid(a(2), 6, Len(a(2)) - 8)
        Call read_a_line(1, strinput)
        elements = split_on_spaces(strinput, a)
        ele = a(0)
        Call read_a_line(1, strinput)
        elements = split_on_spaces(strinput, a)
        dt = Mid(a(0), 7, 10)
        tm = Mid(a(0), 18, 8)
        Call read_a_line(1, strinput)
        event_type = Mid(strinput, 16, InStr(strinput, "]") - 16)
        If event_type = "Picture" Then
            'the photo name is the date and time the shutter was pressed
            Call read_a_line(1, strinput)
            photoOSM = Mid(strinput, 13, InStr(strinput, "jpg") - 10)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            'sat is probably the number of satelites used and might be used to filter unreliable locations
            sat = Mid(strinput, 6, InStr(strinput, "</") - 6)
            Call read_a_line(1, strinput)
            If Dir(phonepath & photoOSM) <> "" Then
                Name phonepath & photoOSM As PhotoLoc & "\photosound\" & photoOSM 'move photo from phone
            End If
            button_state = "Picture"
        ElseIf event_type = "Voice recording" Then
            Call read_a_line(1, strinput)
            'read the name of the voice recording file following the photo without the .3gpp extension
            voiceOSM = Mid(strinput, 13, InStr(strinput, "3gpp") - 9)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            Call read_a_line(1, strinput)
            If button_state = "Picture" Then
            'move the voice file to the PC renaming it to the name of the preceding photo
                If Dir(PhotoLoc & "\photosound\" & Mid(photoOSM, 1, InStr(photoOSM, ".jpg") - 1) & ".3gpp", vbNormal) <> "" Then
                    Kill PhotoLoc & "\photosound\" & Mid(photoOSM, 1, InStr(photoOSM, ".jpg") - 1) & ".3gpp"
                End If
                Name phonepath & voiceOSM As _
                PhotoLoc & "\photosound\" & Mid(photoOSM, 1, InStr(photoOSM, ".jpg") - 1) & ".3gpp"
            Else
                button_state = "Voice recording"
            End If
        ElseIf Left(event_type, 5) = "owned" Or Left(event_type, 5) = "stree" Or Left(event_type, 5) = "commu" Then
            origin = event_type
            Call read_a_line(1, strinput)
            sat = Mid(strinput, 6, InStr(strinput, "</") - 6)
            Call read_a_line(1, strinput)
            button_state = event_type
        ElseIf event_type = "collected" And photoOSM <> "none" Then
            Call read_a_line(1, strinput)
            sat = Mid(strinput, 6, InStr(strinput, "</") - 6)
            Call read_a_line(1, strinput)
            'data written to the capture csv file
            Write #3, dt, lat, lon, photoOSM, sat, origin
            photoOSM = "none"
            origin = "unset"
            dog_type = "unset"
            n_captures = n_captures + 1
            button_state = event_type
        ElseIf event_type = "record sighting" And dog_type <> "unset" And dog_type <> "record sighting" Then
            Call read_a_line(1, strinput)
            sat = Mid(strinput, 6, InStr(strinput, "</") - 6)
            Call read_a_line(1, strinput)
            'data written to the survey csv file
            Write #2, dt, lat, lon, dog_type, sat, photoOSM
            photoOSM = "none"
            dog_type = "unset"
            n_survey_obs = n_survey_obs + 1
            button_state = event_type
        Else
            dog_type = event_type
            Call read_a_line(1, strinput)
            sat = Mid(strinput, 6, InStr(strinput, "</") - 6)
            Call read_a_line(1, strinput)
            button_state = event_type
        End If
    End If
Loop
skip:
Close #3
Close #2
Close #1

Beep
lblDone = "Completed, " & n_survey_obs & " transit observations and " & n_captures & " captures imported to database."
lblNext = "Please 'enter data imported from phone to register' to enter kennel_no etc. for dogs identified on photos"
          
Command1.Enabled = False

End Sub

'Subroutine to read a line into a string from a specified stream if not at EOF
Public Sub read_a_line(ByVal stream_no As Byte, readstring As String)
Dim junk As Byte

readstring = ""
Do While Not EOF(stream_no)
    Get #stream_no, , junk
    'the Ascii code for a tab is 9
    If junk = 9 Or junk = 0 Then
        Get #stream_no, , junk
        Exit Do
    End If
    readstring = readstring & Chr(junk)
Loop

End Sub

'Function to split a string with one or more spaces as delimiter
Public Function split_on_spaces(mystring As String, a() As String) As Byte
Dim nfound As Byte
Dim ind As Byte

a = Split(mystring, " ", -1)
nfound = 0
For ind = 0 To UBound(a)
If Not a(ind) Like "" And Not Left(a(ind), 1) = "[" And Not Right(a(ind), 1) = "]" Then
    a(nfound) = a(ind)
    nfound = nfound + 1
End If
Next ind
split_on_spaces = nfound

End Function

Private Sub Form_Unload(Cancel As Integer)

'delete records from OSMtracker folder ready for next gpx file
If phonepath <> "" And (n_survey_obs > 0 Or n_captures > 0) Then
    Name lblGPXfile.Caption As PhotoLoc & "\saveGPX\" & filename 'move gpx file to avoid data being imported again"
End If

End Sub

